/*!
 * Bootstrap Grunt task for parsing Less docstrings
 * http://getbootstrap.com
 * Copyright 2014-2015 Twitter, Inc.
 * Licensed under MIT (https://github.com/twbs/bootstrap/blob/master/LICENSE)
 */

var Markdown=require("markdown-it");function markdown2html(a){return(new Markdown).render(a.trim()).slice(3,-5)}var CUSTOMIZABLE_HEADING=/^[/]{2}={2}(.*)$/,UNCUSTOMIZABLE_HEADING=/^[/]{2}-{2}(.*)$/,SUBSECTION_HEADING=/^[/]{2}={3}(.*)$/,SECTION_DOCSTRING=/^[/]{2}#{2}(.+)$/,VAR_ASSIGNMENT=/^(@[a-zA-Z0-9_-]+):[ ]*([^ ;][^;]*);[ ]*$/,VAR_DOCSTRING=/^[/]{2}[*]{2}(.+)$/;
function Section(a,b){this.heading=a.trim();this.id=this.heading.replace(/\s+/g,"-").toLowerCase();this.customizable=b;this.docstring=null;this.subsections=[]}Section.prototype.addSubSection=function(a){this.subsections.push(a)};function SubSection(a){this.heading=a.trim();this.id=this.heading.replace(/\s+/g,"-").toLowerCase();this.variables=[]}SubSection.prototype.addVar=function(a){this.variables.push(a)};function VarDocstring(a){this.html=markdown2html(a)}
function SectionDocstring(a){this.html=markdown2html(a)}function Variable(a,b){this.name=a;this.defaultValue=b;this.docstring=null}function Tokenizer(a){this._lines=a.split("\n");this._next=void 0}Tokenizer.prototype.unshift=function(a){if(void 0!==this._next)throw Error("Attempted to unshift twice!");this._next=a};
Tokenizer.prototype._shift=function(){if(void 0!==this._next){var a=this._next;this._next=void 0;return a}if(0>=this._lines.length)return null;var a=this._lines.shift(),b=null,b=SUBSECTION_HEADING.exec(a);if(null!==b)return new SubSection(b[1]);b=CUSTOMIZABLE_HEADING.exec(a);if(null!==b)return new Section(b[1],!0);b=UNCUSTOMIZABLE_HEADING.exec(a);if(null!==b)return new Section(b[1],!1);b=SECTION_DOCSTRING.exec(a);if(null!==b)return new SectionDocstring(b[1]);b=VAR_DOCSTRING.exec(a);if(null!==b)return new VarDocstring(b[1]);
b=a.lastIndexOf("//");a=-1===b?a:a.slice(0,b);b=VAR_ASSIGNMENT.exec(a);if(null!==b)return new Variable(b[1],b[2])};Tokenizer.prototype.shift=function(){for(;;){var a=this._shift();if(void 0!==a)return a}};function Parser(a){this._tokenizer=new Tokenizer(a)}Parser.prototype.parseFile=function(){for(var a=[];;){var b=this.parseSection();if(null===b){if(null!==this._tokenizer.shift())throw Error("Unexpected unparsed section of file remains!");return a}a.push(b)}};
Parser.prototype.parseSection=function(){var a=this._tokenizer.shift();if(null===a)return null;if(!(a instanceof Section))throw Error("Expected section heading; got: "+JSON.stringify(a));var b=this._tokenizer.shift();b instanceof SectionDocstring?a.docstring=b:this._tokenizer.unshift(b);this.parseSubSections(a);return a};
Parser.prototype.parseSubSections=function(a){for(;;){var b=this.parseSubSection();if(null===b)if(0===a.subsections.length)b=new SubSection(""),this.parseVars(b);else break;a.addSubSection(b)}1===a.subsections.length&&(!a.subsections[0].heading&&0===a.subsections[0].variables.length)&&(a.subsections=[])};Parser.prototype.parseSubSection=function(){var a=this._tokenizer.shift();if(a instanceof SubSection)return this.parseVars(a),a;this._tokenizer.unshift(a);return null};
Parser.prototype.parseVars=function(a){for(;;){var b=this.parseVar();if(null===b)break;a.addVar(b)}};Parser.prototype.parseVar=function(){var a=this._tokenizer.shift();a instanceof VarDocstring||(this._tokenizer.unshift(a),a=null);var b=this._tokenizer.shift();if(b instanceof Variable)return b.docstring=a,b;this._tokenizer.unshift(b);return null};module.exports=Parser;