import _ from "underscore";
function isRTL(s){           
    var ltrChars    = 'A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02B8\u0300-\u0590\u0800-\u1FFF'+'\u2C00-\uFB1C\uFDFE-\uFE6F\uFEFD-\uFFFF',
        rtlChars    = '\u0591-\u07FF\uFB1D-\uFDFD\uFE70-\uFEFC',
        rtlDirCheck = new RegExp('^[^'+ltrChars+']*['+rtlChars+']');

    return rtlDirCheck.test(s);
};

/**
 * Creates a bounding rect of all characters in selection
 * @param {Array.<TextSelectionModel.Character>} selection - a list of characters coming from TextSelectionModel.js
 */
const rectFromSelection = selection =>
	selection.length > 0 ? _.reduce(selection, (mem, val) => mem.calculateArea(val.rect), selection[0].rect) : null;

/**
 * Creates a string of all characters in selection
 * @param {Array.<TextSelectionModel.Character>} selection - a list of characters coming from TextSelectionModel.js
 */
const textFromSelection = selection =>
	_.values(_.groupBy(selection, "lineIndex"))
		.map(line => line.map(c => c.character).join(""))
		.join(" ");
export { rectFromSelection, textFromSelection, isRTL };
