export const ADD_ITEM = "ADD_ITEM";
export const REMOVE_ITEM = "REMOVE_ITEM";
export const ADD_LAYOUT_MODE = "ADD_LAYOUT_MODE";
export const SWITCH_LAYOUT_MODE = "SWITCH_LAYOUT_MODE";
export const ACTIVATE_WIDGET = "ACTIVATE_WIDGET";
export const TOGGLE_ITEM = "TOGGLE_ITEM";

export function addItem(name, type, factory) {
	return { type: ADD_ITEM, payload: { type, factory, name } };
}

export function removeItem(name) {
	return { type: REMOVE_ITEM, payload: { name } };
}

export function addLayoutModes(layoutModes) {
	return { type: ADD_LAYOUT_MODE, payload: { layoutModes } };
}

export function switchLayoutMode(layoutModeName) {
	return { type: SWITCH_LAYOUT_MODE, payload: { layoutModeName } };
}

export function activateWidget(widgetName) {
	return { type: ACTIVATE_WIDGET, payload: { widgetName } };
}

export function toggleItem(itemName, enabled) {
	return { type: TOGGLE_ITEM, payload: { itemName, enabled } };
}
