import { generateSheet } from "@esko/react-ui/css";
import React, { useMemo, useState } from "react";
import LayoutContext from "./LayoutContext";
import Messagebar from "./Messagebar";
import Toolbar from "./Toolbar";
import Topbar from "./Topbar";
import Viewport from "./Viewport";
import WidgetBar from "./WidgetBar";

const classes = generateSheet({
	mainContentWrapper: {
		display: "flex",
		flex: "1 1 auto",
		position: "relative",
		overflow: "auto"
	},
	mainContent: {
		display: "flex",
		flex: "1 1 auto",
		flexDirection: "column",
		position: "relative"
	}
});

function Layout() {
	const [mainContent, setMainContent] = useState();
	const layoutContextValue = useMemo(() => ({ mainContent }), [mainContent]);

	return (
		<LayoutContext.Provider value={layoutContextValue}>
			<Topbar />
			<Toolbar />
			<div className={classes.mainContentWrapper}>
				<div className={classes.left}>{/* TODO insert new tool bar */}</div>
				<div className={classes.mainContent}>
					<div className="aboveCenter"></div>
					<Viewport ref={setMainContent} />
					<Messagebar />
				</div>
				<WidgetBar />
			</div>
		</LayoutContext.Provider>
	);
}

export default React.memo(Layout);
