import React, { useRef, useLayoutEffect } from "react";
import { useSelector } from "react-redux";
import { selectMessagebar } from "../LayoutSelect";
import { generateSheet } from "@esko/react-ui/css";
import $ from "jquery";

const classes = generateSheet({
	messagebar: {
		position: "absolute",
		top: "30px",
		left: "30px",
		right: "30px"
	}
});

function Messagebar() {
	const messagebarItem = useSelector(selectMessagebar);
	const divRef = useRef();

	useLayoutEffect(() => {
		if (messagebarItem) {
			messagebarItem.setContext($(divRef.current));
			messagebarItem.resized();
		}
	}, [messagebarItem]);

	return <div className={classes.messagebar} ref={divRef}></div>;
}

export default React.memo(Messagebar);
