import React from "react";
import { useSelector } from "react-redux";
import { selectToolbarComponents } from "../LayoutSelect";
import ToolbarItem from "./ToolbarItem";

function Toolbar() {
	const toolbarComponents = useSelector(selectToolbarComponents);

	return (
		<div className="toolbar">
			{toolbarComponents.map(toolbarName => (
				<ToolbarItem key={toolbarName} name={toolbarName} />
			))}
		</div>
	);
}

export default React.memo(Toolbar);
