import { selectItem, selectIsItemAllowed } from "../LayoutSelect";
import React, { useRef, useEffect } from "react";
import { useSelector } from "react-redux";
import $ from "jquery";

function ToolbarItem({ name }) {
	const item = useSelector(store => selectItem(store, name).getItem());
	const isAllowed = useSelector(store => selectIsItemAllowed(store, name));
	const divRef = useRef();

	useEffect(() => {
		$(divRef.current).append(item.element);
	}, [item]);

	return <div className="toolbar-component-wrapper" style={{ display: isAllowed ? "block" : "none" }} ref={divRef} />;
}

export default React.memo(ToolbarItem);
