import { generateSheet } from "@esko/react-ui/css";
import React from "react";
import { useSelector } from "react-redux";
import { selectMainPanelContent } from "../LayoutSelect";
import Widget from "./Widget";

const classes = generateSheet({
	viewport: {
		display: "flex",
		flex: "1 1 auto"
	}
});

const Viewport = React.forwardRef((props, ref) => {
	const mainpanelContent = useSelector(selectMainPanelContent);
	return (
		<div className={classes.viewport} ref={ref}>
			{mainpanelContent.map(widgetName => (
				<Widget key={widgetName} name={widgetName} />
			))}
		</div>
	);
});

Viewport.displayName = "Viewport";

export default React.memo(Viewport);
