import React from "react";
import { useSelector } from "react-redux";
import { selectWidgets } from "../LayoutSelect";
import WidgetBarItem from "./WidgetBarItem";
import { generateSheet } from "@esko/react-ui/css";

const classes = generateSheet({
	root: {
		flex: "0 1 auto",
		backgroundColor: "#505050",
		color: "white",
		overflow: "auto"
	}
});

function WidgetBar() {
	const widgets = useSelector(selectWidgets);

	return (
		<div className={classes.root}>
			{widgets.map(widget => (
				<WidgetBarItem widgetName={widget} key={widget} />
			))}
		</div>
	);
}

export default React.memo(WidgetBar);
